# ~/.bashrc: executed by bash(1) for non-login shells.
# see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
# for examples

# If not running interactively, don't do anything
case $- in
    *i*) ;;
      *) return;;
esac

# don't put duplicate lines or lines starting with space in the history.
# See bash(1) for more options
HISTCONTROL=ignoreboth

# append to the history file, don't overwrite it
shopt -s histappend
# Allow verification of commands coming from history so they aren't blindy executed
shopt -s histverify

# for setting history length see HISTSIZE and HISTFILESIZE in bash(1)
HISTSIZE=4096
HISTFILESIZE=4096

# check the window size after each command and, if necessary,
# update the values of LINES and COLUMNS.
shopt -s checkwinsize

# If set, the pattern "**" used in a pathname expansion context will
# match all files and zero or more directories and subdirectories.
shopt -s globstar

# make less more friendly for non-text input files, see lesspipe(1)
[ -x /usr/bin/lesspipe ] && eval "$(SHELL=/bin/sh lesspipe)"

# set variable identifying the chroot you work in (used in the prompt below)
if [ -z "${debian_chroot:-}" ] && [ -r /etc/debian_chroot ]; then
    debian_chroot=$(cat /etc/debian_chroot)
fi

# set a fancy prompt (non-color, unless we know we "want" color)
case "$TERM" in
    xterm-color) color_prompt=yes;;
esac

# uncomment for a colored prompt, if the terminal has the capability; turned
# off by default to not distract the user: the focus in a terminal window
# should be on the output of commands, not on the prompt
force_color_prompt=yes

if [ -n "$force_color_prompt" ]; then
    if [ -x /usr/bin/tput ] && tput setaf 1 >&/dev/null; then
	# We have color support; assume it's compliant with Ecma-48
	# (ISO/IEC-6429). (Lack of such support is extremely rare, and such
	# a case would tend to support setf rather than setaf.)
	color_prompt=yes
    else
	color_prompt=
    fi
fi

. ~/.bash_host

prompt_colon()
{
	if [[ -w "$(pwd)" ]]; then
		echo "\[\033[32m\]:\[\033[0m\]"
	else
		echo "\[\033[31m\]:\[\033[0m\]"
	fi
}

set_bash_prompt()
{
	# Update the history file after every command
	# This prevents a loss of history in the case of an unclean exit
	history -a
	PS1="${debian_chroot:+($debian_chroot)}${HOST_COLOUR}\u@\H\[\033[00m\]$(prompt_colon)\[\033[01;34m\]\w\[\033[00m\]"
	if [[ "$UID" = 0 ]]; then
		PS1="${PS1}# "
	else
		PS1="${PS1}\$ "
	fi
}

# https://help.ubuntu.com/community/CustomizingBashPrompt
# Was [01;32m;
if [ "$color_prompt" = yes ]; then
    #if [[ -w "$(pwd)" ]]; then
    #    PROMPT_COLON=$(echo -e "\033[32m:\033[0m")
    #else
    #    PROMPT_COLON=$(echo -e "\033[31m:\033[0m")
    #fi
    
	PROMPT_COMMAND=set_bash_prompt
else
    PS1='${debian_chroot:+($debian_chroot)}\u@\h:\w\$ '
fi
unset color_prompt force_color_prompt

# If this is an xterm set the title to user@host:dir
case "$TERM" in
xterm*|rxvt*)
    PS1="\[\e]0;${debian_chroot:+($debian_chroot)}\u@\h: \w\a\]$PS1"
    ;;
*)
    ;;
esac

# enable color support of ls and also add handy aliases
if [ -x /usr/bin/dircolors ]; then
    test -r ~/.dircolors && eval "$(dircolors -b ~/.dircolors)" || eval "$(dircolors -b)"
    alias ls='ls --color=auto'
    #alias dir='dir --color=auto'
    #alias vdir='vdir --color=auto'

    alias grep='grep --color=auto'
    alias fgrep='fgrep --color=auto'
    alias egrep='egrep --color=auto'
fi

# Add an "alert" alias for long running commands.  Use like so:
#   sleep 10; alert
alias alert='notify-send --urgency=low -i "$([ $? = 0 ] && echo terminal || echo error)" "$(history|tail -n1|sed -e '\''s/^\s*[0-9]\+\s*//;s/[;&|]\s*alert$//'\'')"'

# Set up z.
# More information: https://github.com/rupa/z
#_Z_OWNER=sbrl
#. /home/sbrl/bin/z.sh

# Add pd
. ~/bin/pd-setup.sh

# Alias definitions.
# You may want to put all your additions into a separate file like
# ~/.bash_aliases, instead of adding them here directly.
# See /usr/share/doc/bash-doc/examples in the bash-doc package.

if [ -f ~/.bash_aliases ]; then
    . ~/.bash_aliases
fi

# enable programmable completion features (you don't need to enable
# this, if it's already enabled in /etc/bash.bashrc and /etc/profile
# sources /etc/bash.bashrc).
if ! shopt -oq posix; then
  if [ -f /usr/share/bash-completion/bash_completion ]; then
    . /usr/share/bash-completion/bash_completion
  elif [ -f /etc/bash_completion ]; then
    . /etc/bash_completion
  fi
fi

source ~/bin/commacd.sh

if [[ ! ${NO_HH} ]]; then
	# hh / hstr configuration (https://github.com/dvorka/hstr/)
	export HH_CONFIG=hicolor         # get more colors
	if [[ $- =~ .*i.* ]]; then bind '"\C-r": "\C-a hh \C-j"'; fi
fi

# dh_make configuration
DEBEMAIL="feedback@starbeamrainbowlabs.com"
DEBFULLNAME="Starbeamrainbowlabs"
export DEBEMAIL DEBFULLNAME

# micro true colour support
export MICRO_TRUECOLOR=1;

if [[ ":$PATH:" != *":$HOME/bin:"* ]]; then
	export PATH=$PATH:$HOME/bin;
fi

if [[ ":$PATH:" != *":/sbin:"* ]]; then
	export PATH=$PATH:/sbin;
fi

